import Vue, { PluginFunction, PluginObject, VueConstructor } from 'vue';
import Router from 'vue-router';
import { IComponent } from './component';
import { IDirective } from './directive';
import { IFilter } from './filter';
import { IMixin } from './mixin';
import { IPlugin } from './plugins';
import { IPrototype } from './prototype';
import { IRouter, RouteConfig, RouterOptions } from './router';
import { IStore, StoreOptions } from './store';
declare type IPluginObject<T> = PluginObject<T> | PluginFunction<T>;
export declare namespace Maintainer {
    interface IBuildEnv {
        env: string;
        isLocal: boolean;
        isDev: boolean;
        isStage: boolean;
        isPreProduction: boolean;
        isProduction: boolean;
    }
    interface IMaintainer {
        buildEnv: IBuildEnv;
        router: Router;
        store: IStore<any>;
    }
    interface IOption {
        showLogEnvs?: string[];
        router?: {
            routes?: IRouter;
            fallback?: RouteConfig;
            option?: RouterOptions;
        };
        store?: {
            vuex: IPluginObject<any>;
            root: StoreOptions<any>;
            modules: IStore<any>;
        };
        plugins?: IPlugin<any>;
        serviceWorker?: {
            isRegister?: boolean;
            base?: string;
            file?: string;
        };
        prototype?: IPrototype;
        filter?: IFilter;
        component?: IComponent;
        mixin?: IMixin;
        directive?: IDirective;
    }
    function initialize(vue: VueConstructor<Vue>, maintainerOption: IOption): IMaintainer;
    function getBuildEnv(): IBuildEnv;
}
export {};
